<?php
//define the values below
$cost = ".0005";
$servicename = "Mail Marketing X";
$file = 'lastrun.txt';
$url = ""; # URL to WHMCS API file
$username = ""; # Admin username goes here
$password = ""; # Admin password goes here
//mailing system credentials
$mysqli = new mysqli('127.0.0.1', '', '', '');
//billing system credentials
$mysqli_billing = new mysqli('127.0.0.1', '', '', '');

//this checks to see what the last time stamp was the last time the application ran.  The timestamp is stored in a local file.
$laststamp = file_get_contents($file);

$log .= "Retrieved last timestamp from file: ".$laststamp."\n";

//connect to the billind database
if ($mysqli_billing->connect_errno) {
    $log .= "Could Not Connect to Billing System DB\n";
    $log .= "Error: Failed to make a MySQL connection: \n";
    $log .= "Errno: " . $mysqli->connect_errno . "\n";
    $log .= "Error: " . $mysqli->connect_error . "\n";
    //exit application
    exit;
}
$log .= "Connected to Billing System DB \n";
		
//connect to the mailsystem database
if ($mysqli->connect_errno) { 
	$log .= "Could Not Connect to Mailing System DB \n";
	$log .= "Error: Failed to make a MySQL connection: \n";
	$log .= "Errno: " . $mysqli->connect_errno . "\n";
	$log .= "Error: " . $mysqli->connect_error . "\n";
	exit;
}
$log .= "Connected to Mailing System DB \n";

//query the billing database
$sql = "SELECT `userid`, `value` FROM `tblhosting`,`tblcustomfieldsvalues`  WHERE tblhosting.packageid=36 AND tblhosting.domainstatus = 'Active' AND tblhosting.id = tblcustomfieldsvalues.relid";
//$log .= "QUERY: ".$sql."\n";
if (!$billingresult = $mysqli_billing->query($sql)) {
    $log .= "\nThe Query of the Billing Database failed";
    exit;
}


//$account will hold the account ids and mailing system ids for each account that has the mailing list service 
//this loop loads it up, calulcates the usage and writes a billable item back to the database viat the whmcs API if applicable

while ($account = $billingresult->fetch_assoc()) {
    $accountid = $account['userid'];
	$mailinglistid = $account['value'];
	$log .= "\n\nFound Account: ".$accountid." with a mailing list ID of: ".$mailinglistid."\n";
		
	$totalnewemails = 0;  //set the value to default of 0
		// Perform an SQL query to get the total of emails sent for a particular user
		$sql = "SELECT sum(to_send) as `total` FROM campaigns WHERE app=".$mailinglistid." AND sent > $laststamp";
//		$log .= "QUERY: ".$sql."\n";
		
		if (!$result = $mysqli->query($sql)) {
			// Oh no! The query failed. 
			$log .= "Error: The query of the mailing system database failed to execute: \n";
			$log .= "Query: " . $sql . "\n";
			$log .= "Errno: " . $mysqli->errno . "\n";
			$log .= "Error: " . $mysqli->error . "\n";
			exit;
		}

		$result = $result->fetch_assoc();
		//$totalnewemails holds the number of new emails sent for that particular user
		$totalnewemails = $result['total'];
		$totalcost = $cost * $totalnewemails;
		$log .= "Total Emails: ".$totalnewemails;
		$log .= "\nTotal Cost: ".$totalcost;
		//if the cost is between 0 and 1 cent round up to 1 cent
		if ($totalcost > 0 && $totalcost < .01) 
		{
			$totalroundedcost = .01;	
		}else //otherwise, round it to the nearest cent
		{
			$totalroundedcost = round_up($totalcost,2);
		}
		
		$log .= "\nRounded Cost: ".$totalroundedcost."\n";
		
		
		if($totalroundedcost == 0)
		{
			//don't add any billable lines
		}
		else
		{
			//there is stuff to bill. execute the api call
			 
			 $postfields["username"] = $username;
			 $postfields["password"] = md5($password);
			
			 $postfields["action"] = "addbillableitem"; 
			 $postfields["clientid"] = $accountid;
			 $postfields["description"] = $servicename." - ".$totalnewemails." emails @ .0005/email";
			 $postfields["amount"] = $totalroundedcost;
			 $postfields["recur"] = "1";
			 $postfields["recurcycle"] = "Months";
			 $postfields["recurfor"] = "0";
			 $postfields["invoiceaction"] = "nextinvoice";
			 $postfields["duedate"] = "2009-05-01";
			 
			 $ch = curl_init();
			 curl_setopt($ch, CURLOPT_URL, $url);
			 curl_setopt($ch, CURLOPT_POST, 1);
			 curl_setopt($ch, CURLOPT_TIMEOUT, 100);
			 curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			 curl_setopt($ch, CURLOPT_POSTFIELDS, $postfields);
			 $data = curl_exec($ch);
			 curl_close($ch);
			 
			 $data = explode(";",$data);
			 foreach ($data AS $temp) {
			   $temp = explode("=",$temp);
			   $results[$temp[0]] = $temp[1];
			 }
			 

		}//end else
		

}//end while loop.  We are done with this customer.  Go on to the next


//this will retrieve the most recent timestamp from the campaign list
$sql = "SELECT sent FROM `campaigns` Order By sent DESC LIMIT 1;";
//$log .= "\nQUERY: ".$sql."\n";
if (!$result_timestamp = $mysqli->query($sql)) {
    $log .= "The Update Timestamp Query Failed \n";
    exit;
}


$result_timestamp = $result_timestamp->fetch_assoc();
$newlaststamp = $result_timestamp['sent'];
$log .= "\nNew Last Timestamp: ".$newlaststamp;
file_put_contents($file, $newlaststamp);


$mysqli->close();


$mysqli_billing->close();

//Rounds up to the next cent
function round_up ( $value, $precision ) { 
    $pow = pow ( 10, $precision ); 
    return ( ceil ( $pow * $value ) + ceil ( $pow * $value - ceil ( $pow * $value ) ) ) / $pow; 
} 

header('Content-Type: text/plain');
echo $log;

?>

